% TP 5 de Data Mining : k moyennes et EM
% Auteur : Maxime Chambreuil - Florian Boitrel
% Date : 26 mars 2003
%
% DISTANCE
%
% d = distance(echantillon,centre,type)
%
% ENTREE :
% echantillon : vecteur de l echantillon
% centre : vecteur des centres des clusters
% type : 1-> distance euclidienne
%        2-> distance de Mahalanobis
%
%
% SORTIE :
% d : Matrice des distances
%

function d = distance(echantillon,centre,type)

d = [];
n = size(echantillon,1);
matCov = cov(echantillon);

for i=1:size(centre,1)
     tmp = echantillon - ones(n,1)*centre(i,:);

     if(type==1)
          tmp = sum(tmp.*tmp,2);
          d = [d tmp];
     end
     
     if(type==2)
          d = [ d sum(tmp*inv(matCov+1e-5*eye(size(echantillon,2))).*tmp,2)];
     end
end
