% TP 5 de Data Mining : k moyennes et EM
% Auteur : Maxime Chambreuil - Florian Boitrel
% Date : 26 mars 2003
%
% FORMES FORTES :
%
%  [centreFF,classeFF] = formes_fortes(echantillon,N,nbCentre,methode)
%  
%  ENTREE
%  echantillon : matrice de l echantillon
%  N : Nombre d appel a k_moyennes
%  nbCentre : Nombre de cluster
%  methode : calcul de la distance
%            1 -> Euclidienne
%            2 -> Mahalanobis
%  
%  SORTIE
%  centreFF : Matrice centre des clusters
%  classeFF : vecteur de classe
%

function [centreFF,classeFF] = formes_fortes(echantillon,N,nbCentre,methode)

sauve_classe=[];
centreFF = [];
[nbIndividu,nbVar] = size(echantillon);

% On execute N fois k_moyennes
for i=1:N
   
   [centre,classe]=k_moyennes(echantillon,nbCentre,methode);
   
   % On sauvegarde les attributions
   sauve_classe=[sauve_classe classe];
end

% On recupere les attributions sur toutes les boucles
[Formes inutile classeFF]=unique(sauve_classe,'rows');

aGarder = [];
classeAgarder = [];
nbClasseAgarder = 0;

for i=0:max(classeFF)
     indice = find(classeFF == i);
     if (size(indice,1) > nbIndividu*0.05)
	   nbClasseAgarder = nbClasseAgarder + 1;
           classeAgarder = [ classeAgarder ; repmat(nbClasseAgarder,size(indice),1) ];
           aGarder = [ aGarder ; indice ];
     end
end

centreFF = nouveaux_centres(echantillon(aGarder,:),classeAgarder,nbClasseAgarder);
classeFF = affectation(echantillon,centreFF,1);
centreFF = nouveaux_centres(echantillon,classeFF,max(classeFF));
