% TP 5 de Data Mining : k moyennes et EM
% Auteur : Maxime Chambreuil - Florian Boitrel
% Date : 26 mars 2003
%
% K MOYENNES
%
%  [centre,classe] = k_moyennes(echantillon,nbCentre,methode)
%
%  ENTREE
%  echantillon : matrice de l echantillon
%  nbCentre : Nombre de cluster
%  methode : methode de calcul de la distance
%           1 -> Distance euclidienne
%           2 -> Distance de Mahalanobis
% 
%  SORTIE
%  centre : Matrice des centres des clusters
%  classe : vecteur de classe
%

function [centre,classe] = k_moyennes(echantillon,nbCentre,methode)

[nbIndividu,nbVar] = size(echantillon);
indice = randperm(nbIndividu);
centre = echantillon(indice(1:nbCentre),:);
epsilon = 0.01;
fini = (0==1);

while (~fini)
     classe = affectation(echantillon,centre,methode);
     tmpCentre = nouveaux_centres(echantillon,classe,nbCentre);
     fini = (norm(tmpCentre-centre) < epsilon);
     centre = tmpCentre;
end
